Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package ast
  Definition Classes
    nsc
-  package parser
  Definition Classes
    ast
-  trait Scanners extends ScannersCommon
  Definition Classes
    parser
- CommonTokenData
- DocScanner
- MalformedInput
- ParensAnalyzer
- Scanner
- ScannerCommon
- ScannerData
- SourceFileScanner
- TokenData
- UnitScanner

c

scala.tools.nsc.ast.parser.Scanners

# SourceFileScanner

###

#### class SourceFileScanner extends Scanner

A scanner for a given source file not necessarily attached to a compilation unit. Useful for looking inside source files that are not currently compiled to see what's there

Source
  Scanners.scala

Linear Supertypes
Scanner, Scanners.DocScanner, Scanners.ScannerCommon, ScannerData, TokenData, Scanners.CommonTokenData, CharArrayReader, CharArrayReaderData, AnyRef, Any
Known Subclasses
ParensAnalyzer, UnitScanner, ScaladocUnitScanner
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. SourceFileScanner
2. Scanner
3. DocScanner
4. ScannerCommon
5. ScannerData
6. TokenData
7. CommonTokenData
8. CharArrayReader
9. CharArrayReaderData
10. AnyRef
11. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new SourceFileScanner(source: SourceFile)

### Type Members

1.  class CharArrayLookaheadReader extends CharArrayReader
   Definition Classes
     CharArrayReader

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from SourceFileScanner toany2stringadd[SourceFileScanner] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (SourceFileScanner, B)
   Implicit
     This member is added by an implicit conversion from SourceFileScanner toArrowAssoc[SourceFileScanner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def adjustSepRegions(lastToken: Scanners.Token): Unit
   Definition Classes
     Scanner
7.  def applyBracePatch(): Boolean

   overridden in UnitScanners: apply brace patch if one exists for this offset return true if subsequent end of line handling should be suppressed.

   overridden in UnitScanners: apply brace patch if one exists for this offset return true if subsequent end of line handling should be suppressed.

   Definition Classes
     Scanner
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  val base: Int

   the base of a number

   the base of a number

   Definition Classes
     TokenData
10.  def beginDocComment(prefix: String): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
11.  val buf: Array[Char]
    Definition Classes
      SourceFileScanner → CharArrayReader
12.  val cbuf: java.lang.StringBuilder

    A character buffer for literals

    A character buffer for literals

    Definition Classes
      Scanner
13.  val ch: Char

    the last read character

    the last read character

    Definition Classes
      CharArrayReaderData
14.  def charLitOr(op: () => Unit): Unit

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

    Definition Classes
      Scanner
15.  val charOffset: Int

    The offset one past the last read character

    The offset one past the last read character

    Definition Classes
      CharArrayReaderData
16.  def charVal: Char

    Convert current strVal to char value.

    Convert current strVal to char value.

    Definition Classes
      Scanner
17.  def checkNoLetter(): Unit
    Definition Classes
      Scanner
    Annotations
      @inline()
18.  def checkNoTrailingSeparator(): Unit
    Definition Classes
      Scanner
19.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
20.  def copyFrom(sd: ScannerData): SourceFileScanner.this.type
    Definition Classes
      ScannerData
21.  def copyFrom(td: TokenData): SourceFileScanner.this.type
    Definition Classes
      TokenData
22.  def copyFrom(cd: CharArrayReaderData): SourceFileScanner.this.type
    Definition Classes
      CharArrayReaderData
23.  def deprecationWarning(off: Scanners.Offset, msg: String, since: String): Unit
    Definition Classes
      SourceFileScanner → ScannerCommon
24.  def deprecationWarning(msg: String, since: String): Unit
    Definition Classes
      Scanner
25.  def discardDocBuffer(): Unit

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    Definition Classes
      DocScanner
26.  def doubleVal: Double
    Definition Classes
      Scanner
    Annotations
      @inline()
27.  def doubleVal(negated: Boolean): Double

    Convert current strVal, base to double value.

    Convert current strVal, base to double value.

    Definition Classes
      Scanner
28.  def emitIdentifierDeprecationWarnings: Boolean

    Determines whether this scanner should emit identifier deprecation warnings, e.g.

    Determines whether this scanner should emit identifier deprecation warnings, e.g. when seeing `macro` or `then`, which are planned to become keywords in future versions of Scala.

    Attributes
      protected
    Definition Classes
      Scanner
29.  def ensuring(cond: (SourceFileScanner) => Boolean, msg: => Any): SourceFileScanner
    Implicit
      This member is added by an implicit conversion from SourceFileScanner toEnsuring[SourceFileScanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
30.  def ensuring(cond: (SourceFileScanner) => Boolean): SourceFileScanner
    Implicit
      This member is added by an implicit conversion from SourceFileScanner toEnsuring[SourceFileScanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
31.  def ensuring(cond: Boolean, msg: => Any): SourceFileScanner
    Implicit
      This member is added by an implicit conversion from SourceFileScanner toEnsuring[SourceFileScanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
32.  def ensuring(cond: Boolean): SourceFileScanner
    Implicit
      This member is added by an implicit conversion from SourceFileScanner toEnsuring[SourceFileScanner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
33.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
34.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
35.  def error(off: Scanners.Offset, msg: String): Unit
    Definition Classes
      SourceFileScanner → ScannerCommon
36.  final def fetchToken(): Unit

    read next token, filling TokenData fields of Scanner.

    read next token, filling TokenData fields of Scanner.

    Attributes
      protected
    Definition Classes
      Scanner
    Annotations
      @tailrec()
37.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
38.  def finishDocComment(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
39.  def floatVal: Float
    Definition Classes
      Scanner
    Annotations
      @inline()
40.  def floatVal(negated: Boolean): Float

    Convert current strVal, base to float value.

    Convert current strVal, base to float value.

    Definition Classes
      Scanner
41.  def flushDoc(): Global.DocComment
    Definition Classes
      DocScanner
42.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from SourceFileScanner toStringFormat[SourceFileScanner] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
43.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
44.  def getFraction(): Unit

    read fractional part and exponent of floating point number if one is present.

    read fractional part and exponent of floating point number if one is present.

    Attributes
      protected
    Definition Classes
      Scanner
45.  def getLitChar(): Unit

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    Attributes
      protected
    Definition Classes
      Scanner
46.  def getNumber(): Unit

    Read a number into strVal.

    Read a number into strVal.

    The `base` can be 2, 10 or 16.

    Attributes
      protected
    Definition Classes
      Scanner
47.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
48.  def healBraces(): List[BracePatch]

    overridden in UnitScanners

    overridden in UnitScanners

    Definition Classes
      Scanner
49.  def inFirstOfStat(token: Scanners.Token): Boolean

    Can token start a statement?

    Can token start a statement?

    Definition Classes
      Scanner
50.  def inLastOfStat(token: Scanners.Token): Boolean

    Can token end a statement?

    Can token end a statement?

    Definition Classes
      Scanner
51.  def incompleteInputError(off: Scanners.Offset, msg: String): Unit
    Definition Classes
      SourceFileScanner → ScannerCommon
52.  def incompleteInputError(msg: String): Unit

    signal an error where the input ended in the middle of a token

    signal an error where the input ended in the middle of a token

    Definition Classes
      Scanner
53.  def init(): Unit

    Initialization method: read first char, then first token

    Initialization method: read first char, then first token

    Definition Classes
      Scanner
54.  def intVal: Long
    Definition Classes
      Scanner
    Annotations
      @inline()
55.  def intVal(negated: Boolean): Long

    Convert current strVal, base to long value.

    Convert current strVal, base to long value. This is tricky because of max negative value.

    Conversions in base 2, 10 and 16 are supported. Number separators are skipped on the fly.

    Definition Classes
      Scanner
56.  def invalidEscape(): Unit
    Attributes
      protected
    Definition Classes
      Scanner
57.  def invalidUnicodeEscape(n: Int): Unit
    Attributes
      protected
    Definition Classes
      Scanner
58.  def isAtEnd: Boolean
    Definition Classes
      Scanner
59.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
60.  def isTrailingComma(right: Scanners.Token): Boolean
    Definition Classes
      Scanner
61.  val lastLineStartOffset: Int

    The start offset of the line before the current one

    The start offset of the line before the current one

    Definition Classes
      CharArrayReaderData
62.  val lastOffset: Scanners.Offset

    the offset of the character following the token preceding this one

    the offset of the character following the token preceding this one

    Definition Classes
      TokenData
63.  val lineStartOffset: Int

    The start offset of the current line

    The start offset of the current line

    Definition Classes
      CharArrayReaderData
64.  def lookaheadReader: CharArrayLookaheadReader

    A new reader that takes off at the current character position

    A new reader that takes off at the current character position

    Definition Classes
      CharArrayReader
65.  def lookingAhead[A](body: => A): A
    Definition Classes
      Scanner
66.  val name: Global.TermName

    the name of an identifier

    the name of an identifier

    Definition Classes
      TokenData → CommonTokenData
67.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
68.  val next: TokenData

    we need one token lookahead and one token history

    we need one token lookahead and one token history

    Definition Classes
      ScannerData
69.  final def nextChar(): Unit

    Advance one character; reducing CR;LF pairs to just LF

    Advance one character; reducing CR;LF pairs to just LF

    Definition Classes
      CharArrayReader
70.  final def nextRawChar(): Unit

    Advance one character, leaving CR;LF pairs intact.

    Advance one character, leaving CR;LF pairs intact. This is for use in multi-line strings, so there are no "potential line ends" here.

    Definition Classes
      CharArrayReader
71.  def nextToken(): Unit

    Produce next token, filling TokenData fields of Scanner.

    Produce next token, filling TokenData fields of Scanner.

    Definition Classes
      Scanner → ScannerCommon
72.  def nextTokenAllow(name: Global.Name): Unit

    Get next token, and allow the otherwise deprecated ident `name`

    Get next token, and allow the otherwise deprecated ident `name`

    Definition Classes
      Scanner
73.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
74.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
75.  val offset: Scanners.Offset

    the offset of the first character of the current token

    the offset of the first character of the current token

    Definition Classes
      TokenData
76.  def parenBalance(token: Scanners.Token): Int

    overridden in UnitScanners

    overridden in UnitScanners

    Definition Classes
      Scanner
77.  def postProcessToken(): Unit
    Definition Classes
      Scanner
78.  val prev: TokenData
    Definition Classes
      ScannerData
79.  def processCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
80.  def putChar(c: Char): Unit

    append Unicode character to "cbuf" buffer

    append Unicode character to "cbuf" buffer

    Attributes
      protected
    Definition Classes
      Scanner
81.  final def putCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      Scanner
82.  def registerDocComment(raw: String, pos: Global.Position): Unit
    Definition Classes
      DocScanner
83.  def resume(lastCode: Scanners.Token): Unit
    Definition Classes
      Scanner
84.  var sepRegions: List[Scanners.Token]

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels.

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels. We keep track of the closing symbol of a region. This can be RPAREN if region starts with '(' RBRACKET if region starts with '[' RBRACE if region starts with '{' ARROW if region starts with 'case' STRINGLIT if region is a string interpolation expression starting with '${' (the STRINGLIT appears twice in succession on the stack iff the expression is a multiline string literal).

    Definition Classes
      Scanner
85.  final def skipComment(): Boolean

    Returns true if a comment was skipped.

    Returns true if a comment was skipped.

    Definition Classes
      Scanner
    Note

      Pre-condition: ch == '/'

86.  final def skipNestedComments(): Unit
    Definition Classes
      Scanner
    Annotations
      @tailrec()
87.  def skipToken(): Scanners.Offset

    read next token and return last offset

    read next token and return last offset

    Definition Classes
      Scanner
88.  def skipTrailingComma(right: Scanners.Token): Boolean
    Definition Classes
      Scanner → ScannerCommon
89.  val source: SourceFile
90.  val strVal: String

    the string value of a literal

    the string value of a literal

    Definition Classes
      TokenData
91.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
92.  def syntaxError(msg: String): Unit

    generate an error at the current token offset

    generate an error at the current token offset

    Definition Classes
      Scanner
93.  def syntaxError(off: Scanners.Offset, msg: String): Unit

    generate an error at the given offset

    generate an error at the given offset

    Definition Classes
      Scanner
94.  def toString(): String
    Definition Classes
      Scanner → AnyRef → Any
95.  val token: Scanners.Token

    the next token

    the next token

    Definition Classes
      TokenData → CommonTokenData
96.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
97.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
98.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
99.  def warning(off: Scanners.Offset, msg: String, category: WarningCategory): Unit
    Definition Classes
      SourceFileScanner → ScannerCommon

### Deprecated Value Members

1.  def →[B](y: B): (SourceFileScanner, B)
   Implicit
     This member is added by an implicit conversion from SourceFileScanner toArrowAssoc[SourceFileScanner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Scanner

### Inherited from Scanners.DocScanner

### Inherited from Scanners.ScannerCommon

### Inherited from ScannerData

### Inherited from TokenData

### Inherited from Scanners.CommonTokenData

### Inherited from CharArrayReader

### Inherited from CharArrayReaderData

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromSourceFileScanner to any2stringadd[SourceFileScanner]

### Inherited by implicit conversion StringFormat fromSourceFileScanner to StringFormat[SourceFileScanner]

### Inherited by implicit conversion Ensuring fromSourceFileScanner to Ensuring[SourceFileScanner]

### Inherited by implicit conversion ArrowAssoc fromSourceFileScanner to ArrowAssoc[SourceFileScanner]

### Ungrouped